力扣题11盛做多水的容器
作者:互联网
给你 n 个非负整数 a1,a2,...,an,每个数代表坐标中的一个点 (i, ai) 。在坐标内画 n 条垂直线,垂直线 i 的两个端点分别为 (i, ai) 和 (i, 0) 。找出其中的两条线,使得它们与 x 轴共同构成的容器可以容纳最多的水。
说明:你不能倾斜容器。
示例 1:
输入:[1,8,6,2,5,4,8,3,7]
输出:49
解释:图中垂直线代表输入数组 [1,8,6,2,5,4,8,3,7]。在此情况下,容器能够容纳水(表示为蓝色部分)的最大值为 49。
示例 2:
输入:height = [1,1]
输出:1
示例 3:
输入:height = [4,3,2,1,4]
输出:16
示例 4:
输入:height = [1,2,1]
输出:2
1.暴力解法:但是超出了时间范围。
class Solution {
public int maxArea(int[] height) {
int max = 0;
int current = 0;
for(int i = 0;i < height.length;i++){
for(int j = i + 1;j < height.length;j++){
current = (height[i] > height[j] ? height[j]:height[i]) * (j - i);
if(current > max){
max = current;
}
}
}
return max;
}
}
2.利用一头一尾的两个指针,计算面积,然后向内缩小范围。
面积S = min(height[index1],height[index2])*(index2 - index1)
因为向内缩的过程底会缩小,因此为了找最大值,应该使高增大,所以将两个指针中指向较小值的指针向内缩,看看有没有可能形成足够大的高从而使面积增大。
双指针大多都是对双重循环的优化。要学会根据题目条件找到双指针移动的条件。
class Solution {
public int maxArea(int[] height) {
int index1 = 0;
int index2 = height.length - 1;
int maxArea = 0;
int curArea = 0;
if(index2 - index1 < 1){//形成不了一个面积
return -1;
}
while(index1 < index2){
curArea = (height[index1] > height[index2] ? height[index2]:height[index1]) * (index2 - index1);
if(curArea > maxArea){
maxArea = curArea;
}
if(height[index1] > height[index2]){//因为向里缩的时候,底会变少,因此移动指向值小的指针,向前指向一个新的值
index2--;
}else{
index1++;
}
}
return maxArea;
}
}
题源:力扣
标签:11,int,盛做,height,多水,index2,index1,maxArea,指针 来源: https://blog.csdn.net/xxyneymar/article/details/120481739